#General:
clear @a
bossbar set minecraft:heat players
scoreboard players set @a Heat 0
kill @e[tag=Enemy]
tag @a remove BeaconEnergy
tag @a remove FireUpgrade
bossbar set minecraft:heat max 20
setblock 5 68 5 minecraft:end_portal_frame[eye=false]
setblock 5 68 11 minecraft:end_portal_frame[eye=false]
setblock 11 68 11 minecraft:end_portal_frame[eye=false]
setblock 11 68 5 minecraft:end_portal_frame[eye=false]
kill @e[type=minecart]
summon minecart 72 120 82
tag @a remove GameComplete
scoreboard players set End Time 0
gamemode adventure @a[tag=Playing]
fill 7 74 9 9 74 7 cracked_stone_bricks
tp @a[tag=Playing,tag=!Finale3] 8 300 8
tag @a remove In
gamerule sendCommandFeedback false
scoreboard objectives setdisplay sidebar

#Permanent stuff!
setblock 5 65 8 dirt
setblock 11 65 8 dirt

#Matter (tutorial)
setblock 13 75 32 air
setblock 31 74 28 air
setblock 24 80 50 air
tag @a remove Chap1
tag @a remove Chap2
tag @a remove Chap3
tag @a remove Chap4

#Matter (real puzzles)
setblock 7 83 50 air
setblock -16 87 30 air
setblock -16 91 8 air
setblock -15 90 8 air
setblock -14 91 3 air
setblock -14 90 4 air
setblock -20 95 -3 air
setblock -21 96 -3 air
setblock -25 104 20 air
setblock -26 104 31 air
fill -21 88 26 -21 88 27 air
setblock 3 91 34 air
fill -25 104 31 -27 102 30 air replace minecraft:lever

#Forest part:
setblock 29 97 49 air
setblock 29 97 53 air
setblock 29 97 57 air
setblock 29 97 61 air
data remove block 33 99 78 Items
data remove block 27 102 78 Items
data remove block 24 100 81 Items
data remove block 25 100 86 Items
setblock 25 100 85 air
setblock 27 99 86 air
setblock 4 118 96 air
setblock 4 118 103 minecraft:gold_block
summon guardian 4 119 103 {Tags:["Enemy"],Rotation:[180f,0f],NoAI:1,PersistenceRequired:1}
setblock 4 121 107 air
clone 4 116 103 4 116 103 4 127 103
setblock -18 114 103 air

#Energy
setblock 8 77 -30 ice
fill 9 73 -10 7 75 -10 minecraft:nether_quartz_ore replace minecraft:red_stained_glass
fill 3 74 -16 3 76 -16 minecraft:oak_planks replace air
fill 12 74 -16 12 76 -16 minecraft:oak_planks replace air
fill 8 77 -26 8 79 -26 minecraft:oak_planks replace air
setblock 8 78 -32 air
setblock 25 88 -40 minecraft:oak_planks
setblock 25 89 -41 minecraft:oak_planks
fill 25 90 -42 25 88 -42 minecraft:oak_planks
fill 26 88 -43 26 89 -43 minecraft:oak_planks
fill 35 95 -16 34 96 -16 minecraft:oak_planks
setblock 21 87 -44 air
setblock 24 89 -36 air
data remove block 35 95 -17 Items
setblock 33 100 -19 air
setblock 30 105 -16 ice
setblock 38 102 -19 air
setblock 18 111 -16 air
setblock 8 119 -48 ice
setblock 9 123 -38 air
data remove block 10 125 -47 Items
setblock 10 126 -47 minecraft:oak_planks
setblock 10 125 -48 minecraft:oak_planks
setblock 11 125 -47 minecraft:oak_planks
setblock 10 125 -46 minecraft:oak_planks
setblock 9 125 -47 minecraft:oak_planks
fill 1 127 -41 -1 128 -43 air replace minecraft:lever
data remove block -38 122 -56 Items
setblock -39 129 -47 air
data remove block 6 150 -80 Items
fill 5 155 -91 4 155 -91 air
fill 3 157 -97 6 157 -93 air replace minecraft:lever

#Meteor part:
setblock 4 135 -109 minecraft:magma_block
summon blaze 4 136 -109 {Tags:["Enemy"],Rotation:[180f,0f],NoAI:1,PersistenceRequired:1}
setblock 4 142 -118 air
clone 4 140 -123 4 140 -123 4 142 -123

#Space
setblock -73 69 48 air
setblock -75 68 24 air
setblock -75 83 -28 air
setblock -114 101 31 air
setblock -88 113 70 ice
data remove block -101 112 75 Items
data remove block -98 115 63 Items
setblock -102 119 70 air
data remove block -135 124 31 Items
data remove block -136 127 20 Items
data remove block -147 131 17 Items
data remove block -142 134 8 Items
setblock -143 132 12 ice
setblock -150 138 3 air
setblock -108 100 16 minecraft:oak_planks
setblock -94 102 24 minecraft:oak_planks
setblock -114 104 17 ice
setblock -81 78 -24 air
setblock -78 79 -14 air

#Portal part:
summon phantom -176 138 5 {Tags:["Enemy"],Rotation:[-90f,0f],NoAI:1,PersistenceRequired:1,Attributes:[{Base:1.0d,Name:"generic.knockbackResistance"}]}
setblock -170 141 8 ice
setblock -164 142 -4 air
data remove block -173 148 12 Items
setblock -169 137 -6 air
clone -168 133 4 -168 133 4 -168 135 4
setblock -168 136 4 minecraft:snow_block

#Time
setblock 62 75 -7 air
setblock 60 80 -16 air
setblock 87 83 -6 air
setblock 82 83 -6 air
setblock 88 98 24 air
setblock 84 105 26 air
setblock 87 106 22 air
fill 79 114 66 83 114 66 minecraft:oak_planks
setblock 82 115 66 minecraft:oak_planks
fill 81 114 67 80 114 67 minecraft:oak_planks
setblock 57 118 75 air
fill 59 118 74 59 119 74 minecraft:oak_planks
setblock 57 118 79 air
setblock 67 118 82 air
data remove block 98 137 49 Items
data remove block 103 137 44 Items
setblock 112 135 44 air
setblock 130 141 11 air
setblock 130 141 21 air
data remove block 133 145 16 Items
setblock 151 145 16 air
setblock 198 148 10 air
setblock 86 101 25 air

#Throne part:
summon evoker 192 150 16 {Tags:["Enemy"],Rotation:[90f,0f],NoAI:1,PersistenceRequired:1,Invulnerable:0}
function main:boss/reset
clone 192 146 16 192 146 16 192 148 16
setblock 192 149 16 minecraft:piston[facing=up]
setblock 181 152 23 air
fill 184 148 14 182 148 18 air replace minecraft:lever
setblock 192 148 18 minecraft:piston[facing=west]

#General:
scoreboard players set @e[tag=Enemy] Life 3
scoreboard players set @e[tag=Enemy,type=phantom] Life 4
scoreboard players set @e[tag=Enemy,type=evoker] Life 7

